SystemOrganization addCategory: #'GMF-Generator'!

Object subclass: #CodeGenerator
	instanceVariableNames: ''
	classVariableNames: 'arguments class data index method methods parent temp temp2 variables'
	poolDictionaries: ''
	category: 'GMF-Generator'!

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:59'!
createClass
	| parent |
	class parent isNil ifTrue:[parent := 'Object'] ifFalse:[parent := class parent name].
	self class evaluatorClass
		evaluate:
			parent , ' subclass: #' , class name,'
		instanceVariableNames: ''' , temp,'''
		classVariableNames: ''' , temp2,'''
		poolDictionaries: ''''
		category: ''generatedClasses'''.
	class wasGenerated.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:42'!
createMethod
	self readMethodArguments.
	method isInstance ifTrue: [self class evaluatorClass
		evaluate: 
		'', class name, ' compile: ''', method name , arguments, ' '' ' ]
	ifFalse: [ self class evaluatorClass
		evaluate: 
		'', class name, ' class compile: ''', method name , arguments, ' '' ' ]! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:20'!
createMethods
	methods size == 0 ifFalse:
		[ methods do:[:m | method := m. self createMethod. ]].! !

!CodeGenerator class methodsFor: 'accessing' stamp: 'RostislavNovk 4/8/2013 10:48'!
generateCode: interface
	self readData: interface.
	index := 0.
	self isGenerated whileFalse: [ 
		self readNextClass.
		self readVariables.
		self createClass.
		self readMethods.
		self createMethods.  ]! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:58'!
getStringVariables: xCollection
	| str |
	str := ''.
	xCollection size == 0
		ifFalse: [ xCollection do: [ :v | str := str, ' ' , v name ] ].
	^ str! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:59'!
isGenerated
	^data classes allSatisfy: [:c | c isGenerated ].! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/5/2013 14:16'!
readData: interface  
	data:= interface asGeneratorData.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/6/2013 22:51'!
readMethodArguments
	arguments := ''! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/5/2013 14:18'!
readMethods
	methods:= class methods.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:07'!
readNextClass
	class := data classes detect: [ :c | c isGenerated not ].
		"Transcript show: 'Pred ' , class name; cr."
	[ 
	class parent notNil
		and:
			(class parent isNil
				ifTrue: [ false ]
				ifFalse: [ class parent isGenerated == false ]) ] whileTrue: [ class := class parent ]
		"Transcript show: 'Potom ' , class name; cr"! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:12'!
readVariables
	variables := class variables.
	temp := self getStringVariables: (variables select: [ :v | v isInstance ]).
	temp2 := self getStringVariables: (variables select: [ :v | v isClass ])! !

!CodeGenerator class methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 17:56'!
setData: xData
	data := xData.! !

!CodeGenerator class methodsFor: 'testing' stamp: 'RostislavNovk 4/8/2013 12:16'!
setDataWithAll: xData
	data := xData.
	[self isGenerated] whileFalse: [
		self readNextClass.
		self readVariables.
		self createClass.
		self readMethods.
		self createMethods. ]! !

Object subclass: #GeneratedAll
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAll class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 10:32'!
new
	^ super new
		initialize;
		yourself! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 10:31'!
addClass: aGeneratedClass
	"adding classes"

	classes add: aGeneratedClass.! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:48'!
classes
	^ classes copy! !

!GeneratedAll methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 10:25'!
initialize
	"set numbers of used classes and relations to empty"

	classes := OrderedCollection new.
	^ self! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/7/2013 23:30'!
removeClass: aGeneratedClass
	"remove  classes"

	classes := classes reject:[: c| c == aGeneratedClass.]! !

Object subclass: #GeneratedClass
	instanceVariableNames: 'name comment variables methods superClass generated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:43'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment Code: xCode
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		code: xCode;
		yourself! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addMethod: aGeneratedEOCMethod
	"add to sortedcollection"

	methods add: aGeneratedEOCMethod! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addVariable: aGeneratedEOCVariable
	"add to sortedcollection"

	variables add: aGeneratedEOCVariable! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
comment
	^comment.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:50'!
comment: xComment
	comment:= xComment.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/8/2013 00:26'!
initialize
	variables:= OrderedCollection new.
	methods:= OrderedCollection new.
	comment:=''.
	superClass:=nil.
	generated := false.
	! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/8/2013 00:25'!
isGenerated
	^generated! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 11:07'!
isSubClass
	[ superClass isNil ]
		ifTrue: [ ^ false ]
		ifFalse: [ ^ true ]! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
methods
	^methods copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
name
	^name.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:50'!
name: xName
	name:= xName.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
parent
	^superClass.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
parent: xGeneratedClass
	superClass:= xGeneratedClass .! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
variables
	^variables copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/8/2013 00:26'!
wasGenerated
	generated := true.! !

Object subclass: #GeneratedElementOfClass
	instanceVariableNames: 'name instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

GeneratedElementOfClass subclass: #GeneratedEOCMethod
	instanceVariableNames: 'code arguments abstract'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:31'!
newName: xName
	^ (super newName: xName)
		initialize;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 18:56'!
newName: xName Abstract: xAbstract
	^ (super newName: xName)
		abstract: xAbstract;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:46'!
newName: xName Code: xCode
	^ (super newName: xName)
		code: xCode;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 18:56'!
newName: xName Instance: xInstance Abstract: xAbstract
	^ (super newName: xName Instance: xInstance)
		abstract: xAbstract;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:46'!
newName: xName Instance: xInstance Code: xCode
	^ (super newName: xName Instance: xInstance)
		code: xCode;
		yourself! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:56'!
abstract: xAbstract
	abstract := xAbstract.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:28'!
addArgument: xGeneratedEOCVariable
	arguments add: xGeneratedEOCVariable! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
arguments
	^ arguments copy! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
code
	^ code! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:47'!
code: xCode 
	code := xCode.! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/8/2013 12:46'!
initialize
	instance := true.
	arguments:= OrderedCollection new.! !

!GeneratedEOCMethod methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 18:55'!
isAbstract
	^abstract! !

GeneratedElementOfClass subclass: #GeneratedEOCVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:46'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:45'!
newName: xName Instance: xInstance
	^ super new
		name: xName;
		instance: xInstance;
		yourself! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:01'!
initialize
	instance := true
! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:51'!
instance: xInstance
	instance:=xInstance.
! !

!GeneratedElementOfClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 18:01'!
isClass
	"returns opposite of isInstantce"

	^ instance = false! !

!GeneratedElementOfClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 17:59'!
isInstance
	^ instance! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:52'!
name
	^ name! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:51'!
name: xName
	name := xName.
! !
